#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from astra_csp_cryptopro.utils import Utils


class ArchiveMount:
    def __init__(self, filepath: str, mountdir: str) -> None:
        self.__filepath = filepath
        self.__target = mountdir

    def mount(self) -> None:
        Utils.execute('archivemount', ['-o', 'nobackup', self.__filepath, self.__target])

    def unmount(self) -> None:
        Utils.execute('fusermount', ['-u', self.__target])
