#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from typing import Optional

from PyQt5.QtCore import QThread, QObject


class BaseThread(QThread):
    def __init__(self, parent: QObject = None) -> None:
        super().__init__(parent)
        self._terminated = True
        self._error = None  # type: Optional[str]

    @property
    def terminated(self) -> bool:
        return self._terminated

    @property
    def error(self) -> Optional[str]:
        return self._error
