#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import QDateTime

from astra_csp_cryptopro.certificate_process import Certificate


class CertificateInfo(dict):
    def __init__(self, cert: Certificate) -> None:
        super().__init__()
        self.update(cert)
        self.__convert_date_values()

    def __convert_date_values(self) -> None:
        for key in ['Not valid before', 'Not valid after']:
            self.__convert_date_value(key)

    def __convert_date_value(self, key: str) -> None:
        if key in self:
            self[key] = self.__convert_date(self[key])

    def __convert_date(self, date: str) -> str:
        datetime = QDateTime.fromString(date, 'dd/MM/yyyy  HH:mm:ss t')
        return datetime.date().toString('dd.MM.yyyy')
