#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from typing import List

from PyQt5.QtCore import QObject

from astra_csp_cryptopro.base_thread import BaseThread
from astra_csp_cryptopro.container import Container


class ContainerCreationThread(BaseThread):
    def __init__(self,
                 container: Container,
                 files: List[str],
                 update: bool = False,
                 parent: QObject = None) -> None:
        super().__init__(parent)
        self.__container = container
        self.__files = files
        self.__update = update

    @property
    def container(self) -> Container:
        return self.__container

    def run(self) -> None:
        try:
            self.__container.save(self.__files, self.__update)
        except Exception as exception:
            self._error = str(exception)
        self._terminated = False
