#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from re import match

from PyQt5.Qt import QApplication
from PyQt5.QtCore import QProcess

from astra_csp_cryptopro.process import Process
from astra_csp_cryptopro.utils import Utils

translate = QApplication.translate


class Package:
    @staticmethod
    def installed(package_name: str) -> bool:
        process = Process()
        process.start('dpkg-query -W -f=\"${{status}}\" {package_name}'.format(package_name=package_name))
        process.waitForFinished()

        if process.completed_result.error is not None:
            raise Exception(process.errorString())

        if process.completed_result.exit_status != QProcess.NormalExit:
            raise Exception(process.errorString())

        if process.completed_result.exit_code == 1:
            return False
        elif process.completed_result.exit_code != 0:
            raise Exception(translate('text', 'Process exited with unexpected code: {code}')
                            .format(code=process.completed_result.exit_code))

        result = match('^install ok installed', Utils.to_utf8(process.standard_output_buffer))
        return result is not None
