#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import QDir

from astra_csp_cryptopro.cprocsp_process import CprocspProcess


class VerifyFileProcess(CprocspProcess):
    def __init__(self, bin_dir: QDir) -> None:
        super().__init__(bin_dir=bin_dir)
        self.__setup()

    def setup_arguments(self, file_path: str, check_timestamp: bool = False, sig_path: str = None) -> None:
        arguments = ['-verify']
        if sig_path:
            arguments += ['-verall', '-detached']
            if check_timestamp:
                arguments.append('-cadest')
            arguments += [file_path, sig_path]
        else:
            if check_timestamp:
                arguments.append('-cadest')
            arguments.append(file_path)

        self.setArguments(arguments)

    def __setup(self) -> None:
        self.set_bin_name('cryptcp')
