#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import QThread
from PyQt5.QtGui import QCloseEvent
from PyQt5.QtWidgets import QWidget, QAbstractButton, QDialogButtonBox

from astra_csp_cryptopro.wait_dialog import WaitDialog


class WaitThreadDialog(WaitDialog):
    def __init__(self, thread: QThread, parent: QWidget) -> None:
        super().__init__(parent)
        self.__thread = thread
        self.mainButtonBox.clicked.connect(self.__on_buttonbox_clicked)
        self.__thread.finished.connect(self.__on_thread_finished)

    def __on_buttonbox_clicked(self, button: QAbstractButton) -> None:
        if self.mainButtonBox.standardButton(button) == QDialogButtonBox.Cancel:
            self.__thread.terminate()

    def __on_thread_finished(self) -> None:
        self.close()

    # noinspection PyPep8Naming
    def closeEvent(self, _: QCloseEvent) -> None:
        self._cancelled = True
        if self.__thread.isRunning():
            self.__thread.terminate()
